#include "stdafx.h"
#include "Macros.h"
#include "FrontEnd.h"
#include "HookProcs.h"
#include "Tlhelp32.h"
#include <shlwapi.h>
#include "MainWindow.h"
#include "SmartHKEY.h"


FrontEnd	g_front_end;
HWND		g_main_window;
#define		HOOK_DLL_NAME _T("AutorunProtect_Hook.dll")
#define		EXPLORER_IMAGE_NAME _T("Explorer.exe")
#define		CAPTION _T("Autorun Protect")
#define		CMD_ENABLE _T("-enable")

FrontEnd::FrontEnd(void):
m_start_spy(false)
{
	{
		TCHAR dll_file_name[MAX_PATH];
		GetModuleFileName(NULL,dll_file_name,COUNTOF(dll_file_name));
		PathRemoveFileSpec(dll_file_name);
		m_inject_module_path=dll_file_name;
		m_inject_module_path+=_T("\\")HOOK_DLL_NAME;
	}

	{
		DWORD process_id;
		GetExplorerProcess(&process_id);
		m_start_spy=IsModulePresent(process_id,HOOK_DLL_NAME,NULL);
	}
}

FrontEnd::~FrontEnd(void)
{
}


void FrontEnd::StartSpy()
{
	if(m_start_spy)
		return;

	DWORD process_id;
	GetExplorerProcess(&process_id);
	if( !IsModulePresent(process_id,HOOK_DLL_NAME,NULL ) )
		HookProcs::InjectModule(process_id,&m_inject_module_path[0]);

	m_start_spy=true;
}

void FrontEnd::StopSpy()
{
	DWORD		process_id;
	CAtlString	actual_module_name;
	GetExplorerProcess(&process_id);
	if( IsModulePresent(process_id,HOOK_DLL_NAME,&actual_module_name) )
		HookProcs::EdjectModule(process_id,CAtlStringA(actual_module_name));

	m_start_spy=false;
}

void FrontEnd::GetExplorerProcess(DWORD* process_id)
{
	DWORD				result_id=-1;
	BOOL				br;
	HANDLE				snapshot;
	PROCESSENTRY32		info;

	snapshot=CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS,NULL);
	info.dwSize=sizeof(info);
	br=Process32First(snapshot,&info);
	return_if_equal(br,FALSE);
	do 
	{
		if( 0 == _tcsicmp(info.szExeFile, EXPLORER_IMAGE_NAME) )
		{
			result_id=info.th32ProcessID;
			break;
		}

		info.dwSize=sizeof(info);
	}while(FALSE!=Process32Next(snapshot,&info));
	CloseHandle(snapshot);

	assert_if_equal(result_id,-1);
	*process_id=result_id;
}

bool FrontEnd::IsModulePresent(DWORD process_id, LPCTSTR module_short_name, 
							   CAtlString* module_actual_name)
{
	BOOL			br;
	HANDLE			snapshot;
	MODULEENTRY32	info;
	bool			res=false;

	snapshot=CreateToolhelp32Snapshot(TH32CS_SNAPMODULE,process_id);
	if(INVALID_HANDLE_VALUE==snapshot)
		return false;
	info.dwSize=sizeof(info);
	br=Module32First(snapshot,&info);
	return_x_if_equal(br,FALSE,false);
	do 
	{
		CAtlString actual_path=info.szExePath;
		PathStripPath(info.szExePath);
		if(0 == _tcsicmp(module_short_name,info.szExePath) )
		{
			if(module_actual_name!=NULL)
				*module_actual_name=actual_path;
			res=true;
			break;
		}

		info.dwSize=sizeof(info);
	}while(FALSE!=Module32Next(snapshot,&info));
	CloseHandle(snapshot);

	return res;
}

void FrontEnd::InstallAutorun()
{
	SmartHKEY	key;
	TCHAR		file_name[MAX_PATH];
	TCHAR		reg_value[MAX_PATH*2];
	DWORD		reg_value_used_char_count;
	DWORD		dr;

	dr=GetFileAttributes(&m_inject_module_path[0]);
	return_if_equal(dr,-1);
	return_if_equal((dr&FILE_ATTRIBUTE_DIRECTORY)!=0,true);
	

	dr=GetModuleFileName(NULL,file_name,COUNTOF(file_name));
	return_if_equal(dr,0);
	reg_value_used_char_count=_stprintf(reg_value,_T("%s ")CMD_ENABLE,file_name);
	dr=RegOpenKey(HKEY_CURRENT_USER,_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"),&key);
	return_if_not_equal(dr,ERROR_SUCCESS);
	dr=RegSetValueEx(key,_T("Autorun Protect"),0,REG_SZ,
			(BYTE*)reg_value,reg_value_used_char_count*sizeof(reg_value[0]));
	return_if_not_equal(dr,ERROR_SUCCESS);
}

void FrontEnd::UninstallAutorun()
{
	SmartHKEY	key;
	DWORD		dr;

	dr=RegOpenKey(HKEY_CURRENT_USER,_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"),&key);
	return_if_not_equal(dr,ERROR_SUCCESS);
	dr=RegDeleteValue(key,_T("Autorun Protect"));
	return_if_not_equal(dr,ERROR_SUCCESS);
}

void FrontEnd::DeleteAutorun(const std::vector<CAtlString>& inf_files)
{
	std::vector<CAtlString> not_deleted_files;

	for( size_t i=0; i<inf_files.size(); i++ )
	{
		BOOL br=::DeleteFile(inf_files[i]);
		if(br==FALSE)
			not_deleted_files.push_back(inf_files[i]);
	}

	if(!not_deleted_files.empty())
	{
		CAtlString message;
		message.Format(_T("Remove you removable device to avoid virus infection!\r\n")
						_T("This files was not deleted\r\n"));
		for( size_t i=0; i<not_deleted_files.size(); i++ )
			message.AppendFormat(_T("%s\r\n"),LPCTSTR(not_deleted_files[i]));
		MessageBox(NULL,message,CAPTION,MB_OK|MB_ICONERROR);
	}
}

void FrontEnd::CheckAutorun()
{
	std::vector<CAtlString>	inf_files;
	TCHAR all_drive_names[MAX_PATH];
	GetLogicalDriveStrings(COUNTOF(all_drive_names),all_drive_names);

	for( size_t i=0; all_drive_names[i]!=NULL; i+=_tcslen(all_drive_names)+1 )
	{
		CAtlString	file_name;
		DWORD		file_attributes;

		file_name=&all_drive_names[i];
		file_name+=_T("autorun.inf");
		file_attributes=GetFileAttributes(file_name); 
		if(file_attributes==-1)
			continue;

		inf_files.push_back(file_name);		
	}

	if(inf_files.empty())
		return;

	const char* dlg_result;
	ShowAutorunDetected(&dlg_result);
	if( 0==strcmp("cancel",dlg_result) )
		return;
	if( 0==strcmp("delete",dlg_result) )
	{
		DeleteAutorun(inf_files);
	}
	if( 0==strcmp("view",dlg_result) )
	{
	}

}

bool FrontEnd::IsActiveProtection()
{
	return m_start_spy;
}

bool FrontEnd::IsInstalled()
{
	SmartHKEY	key;
	DWORD		dr;

	RegOpenKey(HKEY_CURRENT_USER,_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"),&key);
	dr=RegQueryValueEx(key,_T("Autorun Protect"),0,NULL,NULL,0);
	return (dr==ERROR_SUCCESS);
}

int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
									LPTSTR lpCmdLine, int nCmdShow)
{
//  	g_front_end.CheckAutorun();

	// OK
//  	g_front_end.InstallAutorun();
//  	g_front_end.UninstallAutorun();
	// OK
//  	MessageBox(NULL,lpCmdLine,CAPTION,MB_OK);
				    
	if( _tcsstr(lpCmdLine,_T("-install")) )
	{
		g_front_end.InstallAutorun();
		g_front_end.StartSpy();
		return 0;
	}
	if( _tcsstr(lpCmdLine,_T("-uninstall")) )
	{
		g_front_end.StopSpy();
		g_front_end.UninstallAutorun();
		return 0;
	}
	if( _tcsstr(lpCmdLine,_T("-disable")) )
	{
		g_front_end.StopSpy();
		return 0;
	}
	if( _tcsstr(lpCmdLine,_T("-enable")) )
	{
		g_front_end.StopSpy();
		g_front_end.StartSpy();
		return 0;
	}

// 	?
	//          .

	MainWindowCreate(hInstance,&g_main_window);

	MSG msg;
	while(FALSE!=GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;
}

