#include "StdAfx.h"
#include "MainWindow.h"
#include "resource.h"
#include "FrontEnd.h"
#include "Macros.h"

INT_PTR ProcessCommand(HWND hDlg, WORD ctrl_id, WORD nc_code)
{
	switch(ctrl_id) 
	{
	case IDOK: 
	case IDCANCEL: 
		EndDialog(hDlg, ctrl_id);
		PostQuitMessage(0);
		return TRUE;
	case IDC_BTN_DELETE:
	case IDC_BTN_VIEW:
		EndDialog(hDlg, ctrl_id);
		return TRUE;
	case IDC_ACTIVATE_PROTECTION:
		if(BN_CLICKED==nc_code)
		{
			UINT val=IsDlgButtonChecked(hDlg,IDC_ACTIVATE_PROTECTION);
			if(BST_CHECKED==val)
				g_front_end.StartSpy();
			if(BST_UNCHECKED==val)
				g_front_end.StopSpy();
		}
		break;
	case IDC_ACTIVATE_ON_START:
		if(BN_CLICKED==nc_code)
		{
			UINT val=IsDlgButtonChecked(hDlg,IDC_ACTIVATE_ON_START);
			if(BST_CHECKED==val)
				g_front_end.InstallAutorun();
			if(BST_UNCHECKED==val)
				g_front_end.UninstallAutorun();
		}
		break;
	
// 	case IDC_BTN_START:
// 		g_front_end.StartSpy();
// 		return TRUE;
// 	case IDC_STOP:
// 		g_front_end.StopSpy();
// 		return TRUE;
		
	}

	return FALSE;
}

INT_PTR ProcessCommand_AutorunDetected(HWND hDlg, WORD ctrl_id)
{
	switch(ctrl_id) 
	{
	case IDCANCEL: 
	case IDC_BTN_DELETE:
	case IDC_BTN_VIEW:
		EndDialog(hDlg, ctrl_id);
		return TRUE;
	}

	return FALSE;
}

INT_PTR CALLBACK MainDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		if(g_front_end.IsActiveProtection())
			CheckDlgButton(hDlg,IDC_ACTIVATE_PROTECTION,BST_CHECKED);
		if(g_front_end.IsInstalled())
			CheckDlgButton(hDlg,IDC_ACTIVATE_ON_START,BST_CHECKED);
		return TRUE;

	case WM_COMMAND:					 
		return ProcessCommand(hDlg,LOWORD(wParam),HIWORD(wParam));
		break;
	}
	return FALSE;
}


INT_PTR CALLBACK AutorunDetectedDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_COMMAND:
		return ProcessCommand_AutorunDetected(hDlg,LOWORD(wParam));
		break;
	}
	return FALSE;
}


void AddLogString(HWND hDlg,LPCTSTR str)
{
	HWND item=GetDlgItem(hDlg,IDC_LIST2);
	SendMessage(item,LB_ADDSTRING,0,LPARAM(str));
}

void MainWindowCreate(HINSTANCE hInstance, HWND* hDlg)
{
	*hDlg=CreateDialog(hInstance, (LPCTSTR)IDD_ABOUTBOX, NULL, &MainDlgProc);
}

void ShowAutorunDetected(const char** result)
{
	INT_PTR ir;
	char* actual_result;
	ir=DialogBox(NULL,(LPCTSTR)IDD_AUTORUN_DETECTED,NULL,AutorunDetectedDlgProc);
	assert_if_equal((ir==0)||(ir==1),true);

	switch(ir) 
	{
	case IDC_BTN_DELETE:
		actual_result="delete";
		break;
	case IDC_BTN_VIEW:
		actual_result="view";
		break;
	default: actual_result="cancel";
	}

	if(result!=NULL)
		*result=actual_result;
}
