#include "StdAfx.h"
#include "SmartHKEY.h"
#include "Macros.h"

SmartHKEY::SmartHKEY():
m_handle(NULL)
{
};

SmartHKEY::~SmartHKEY()
{ 
	Close();
};

void SmartHKEY::Set(HKEY handle)
{
	Close();
	m_handle=handle; 
};

void SmartHKEY::Close()
{
	if( m_handle != NULL) 
	{
		LONG lr;
		lr=RegCloseKey(m_handle); 
		assert_if_not_equal(lr,ERROR_SUCCESS);
	}
	m_handle=NULL; 
}

HKEY SmartHKEY::Get()
{
	return m_handle;
};

PHKEY SmartHKEY::Ref()
{	
	Close();
	return &m_handle;
}

HKEY SmartHKEY::Detach()
{
	HKEY ret;
	ret=m_handle;
	m_handle=NULL;
	return ret;
}

HKEY* SmartHKEY::operator&()
{
	return &m_handle;
}

SmartHKEY::operator HKEY()
{
	return m_handle;
}
