#include "StdAfx.h"
#include "HookDelayLoadedDll.h"
#include "Macros.h"
#include "HookProcs.h"
#include "HookPool.h"
#include "THook.h"

HookDelayLoadedDll*	HookDelayLoadedDll::s_inst;

HookDelayLoadedDll::HookDelayLoadedDll(HookPool* additional_hooks):
m_additional_hooks(additional_hooks),
m_hook_pool(),
m_LoadLibraryA(&m_hook_pool,_T("Kernel32.dll"),"LoadLibraryA",
			   Hook_Internal_LoadLibraryA,LoadLibraryA),
			   m_LoadLibraryW(&m_hook_pool,_T("Kernel32.dll"),"LoadLibraryW",
			   Hook_Internal_LoadLibraryW,LoadLibraryW),
			   m_LoadLibraryExA(&m_hook_pool,_T("Kernel32.dll"),"LoadLibraryExA",
			   Hook_Internal_LoadLibraryExA,LoadLibraryExA),
			   m_LoadLibraryExW(&m_hook_pool,_T("Kernel32.dll"),"LoadLibraryExW",
			   Hook_Internal_LoadLibraryExW,LoadLibraryExW)
{
	s_inst=this;
	m_hook_pool.SetAllHooks();
}

HookDelayLoadedDll::~HookDelayLoadedDll(void)
{
	s_inst=NULL;
}

HMODULE WINAPI HookDelayLoadedDll::Hook_Internal_LoadLibraryW(
	IN LPCWSTR lpLibFileName
	)
{
	HMODULE call_result;
	call_result=s_inst->m_LoadLibraryW.m_original(lpLibFileName);
	if(call_result!=NULL)
		s_inst->m_additional_hooks->SetNotSetedHooks();
	return call_result;
}

HMODULE WINAPI HookDelayLoadedDll::Hook_Internal_LoadLibraryA(
	IN LPCSTR lpLibFileName
	)
{
	HMODULE call_result;
	call_result=s_inst->m_LoadLibraryA.m_original(lpLibFileName);
	if(call_result!=NULL)
		s_inst->m_additional_hooks->SetNotSetedHooks();
	return call_result;
}

HMODULE WINAPI HookDelayLoadedDll::Hook_Internal_LoadLibraryExA(IN LPCSTR lpLibFileName,
																IN HANDLE hFile,
																IN DWORD dwFlags)
{
	HMODULE call_result;
	call_result=s_inst->m_LoadLibraryExA.m_original(lpLibFileName,hFile,dwFlags);
	if(call_result!=NULL)
		s_inst->m_additional_hooks->SetNotSetedHooks();
	return call_result;
}

HMODULE WINAPI HookDelayLoadedDll::Hook_Internal_LoadLibraryExW(IN LPCWSTR lpLibFileName,
																IN HANDLE hFile,
																IN DWORD dwFlags)
{
	HMODULE call_result;
	call_result=s_inst->m_LoadLibraryExW.m_original(lpLibFileName,hFile,dwFlags);
	if(call_result!=NULL)
		s_inst->m_additional_hooks->SetNotSetedHooks();
	return call_result;
}
