#pragma once

#include "HookPool.h"
#include "THook.h"

class HookDelayLoadedDll
{
public:
	HookDelayLoadedDll(HookPool* additional_hooks);
	~HookDelayLoadedDll(void);

private:

	static HMODULE WINAPI Hook_Internal_LoadLibraryA(IN LPCSTR lpLibFileName);
	static HMODULE WINAPI Hook_Internal_LoadLibraryW(IN LPCWSTR lpLibFileName);

	static HMODULE WINAPI Hook_Internal_LoadLibraryExA(
		IN LPCSTR lpLibFileName,
		IN HANDLE hFile,
		IN DWORD dwFlags
		);
	static HMODULE WINAPI Hook_Internal_LoadLibraryExW(
		IN LPCWSTR lpLibFileName,
		IN HANDLE hFile,
		IN DWORD dwFlags
		);
private:														
	static HookDelayLoadedDll*	s_inst;

	HookPool*		m_additional_hooks;
	HookPool		m_hook_pool;

	THook<HMODULE WINAPI(LPCSTR)> m_LoadLibraryA; 
	THook<HMODULE WINAPI(LPCWSTR)> m_LoadLibraryW; 

	THook<HMODULE WINAPI(LPCSTR,HANDLE,DWORD)> m_LoadLibraryExA; 
	THook<HMODULE WINAPI(LPCWSTR,HANDLE,DWORD)> m_LoadLibraryExW; 
};

