#include "StdAfx.h"
#include "HookPool.h"

HookPool::HookPool(void)
{
}

HookPool::~HookPool(void)
{
	ClearSetedHooks();
}

void HookPool::AddHook(IHook* seted_hook)
{
	m_module_hook.push_back(seted_hook);
}

void HookPool::SetAllHooks()
{
	for( size_t i=0; i<m_module_hook.size(); i++ )
		m_module_hook[i]->SetHook();
}

void HookPool::ClearSetedHooks()
{
	for( size_t i=0; i<m_module_hook.size(); i++ )
		m_module_hook[i]->ClearHook();
}

void HookPool::SetModuleHooks(const char* module_name)
{
	for( size_t i=0; i<m_module_hook.size(); i++ )
	{
		const char* hook_module_name=m_module_hook[i]->ModuleName();
		if( 0 == strcmp(module_name,hook_module_name) )
			m_module_hook[i]->SetHook();
	}
}

void HookPool::SetNotSetedHooks()
{
	for( size_t i=0; i<m_module_hook.size(); i++ )
		if(!m_module_hook[i]->IsSeted())
			m_module_hook[i]->SetHook();
}
