#define _WIN32_WINNT 0x0501
#include <Windows.h>
#include <tchar.h>
#include "Macros.h"
#include "THook.h"

struct Hooks
{
	Hooks(IHookPool* hook_pool):
	m_GetFileAttributesW(hook_pool,_T("Kernel32.dll"),"GetFileAttributesW",Hook_GetFileAttributesW,GetFileAttributesW){}

	THook<DWORD WINAPI(LPCWSTR)> 
		m_GetFileAttributesW; 

	static DWORD WINAPI Hook_GetFileAttributesW(
		IN LPCWSTR lpFileName
		);
};

Hooks*		g_hook;

class Initialiser
{
public:
	Initialiser():
	m_hooks(NULL)
	{
		g_hook=&m_hooks;
	}

	~Initialiser()
	{
		g_hook=NULL;
	}

private:
	Hooks			m_hooks;
};

BYTE g_init_mem[sizeof Initialiser];
Initialiser* g_init;

//-------------------------------------------------------
DWORD WINAPI Hooks::Hook_GetFileAttributesW(
	IN LPCWSTR lpFileName
	)
{
	if(0==lstrcmpiW(&lpFileName[1],L":\\autorun.inf"))
	{
		SetLastError(ERROR_FILE_NOT_FOUND);
		return -1;
	}

	DWORD	api_result;
	api_result=g_hook->m_GetFileAttributesW.m_original(lpFileName);
	return api_result;
}

//-------------------------------------------------------

extern "C" int _purecall()
{
	return 0;
}

inline void *__cdecl operator new(size_t, void *_Where)
{	// construct array with placement at _Where
	return (_Where);
}

inline void __cdecl operator delete(void *)
{	// delete if placement new fails
}

//-------------------------------------------------------

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		g_init=new(g_init_mem) Initialiser;
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		delete(g_init),g_init;
		break;
	}
    return TRUE;
}
